
#include <Trade\Trade.mqh>
CTrade trade;

//--New Bar Code
bool isNewBar(string,ENUM_TIMEFRAMES)
  {
   static long last_time=0;
   long lastbar_time=SeriesInfoInteger(_Symbol,PERIOD_M5,SERIES_LASTBAR_DATE);
   
   if(last_time==0)
     {
      //--- set the time and exit
      last_time=lastbar_time;
      return(false);
     }
   
   if(last_time!=lastbar_time)
     {
      //--- memorize the time and return true
      last_time=lastbar_time;
      return(true);
     }
      
   return(false);
  }

void OnTick()
   {    
   
   double Ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   double Bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
   
   //--HOURLY TREND?
   double ema_1H_50=iMA(_Symbol,PERIOD_H1,50,1,1,PRICE_CLOSE);
   double ema_1H_200=iMA(_Symbol,PERIOD_H1,200,1,1,PRICE_CLOSE);
   string hourly_trend="";
   if(ema_1H_50>ema_1H_200)
      {
      hourly_trend="Hourly uptrend";
      }
   else
      {
      hourly_trend="Hourly downtrend";
      }   

   //--15 MINUTE TREND?
   double ema_M15_50=iMA(_Symbol,PERIOD_M15,50,1,1,PRICE_CLOSE);
   double ema_M15_200=iMA(_Symbol,PERIOD_M15,200,1,1,PRICE_CLOSE);
   string M15_trend="";
   if(ema_M15_50>ema_M15_200)
      {
      M15_trend="M15 uptrend";
      }
   else
      {
      M15_trend="M15 downtrend";
      }
   
   //--PREVIOUS CANDLE BULLISH PIN?
   MqlRates PrevPriceInfo[];
   ArraySetAsSeries(PrevPriceInfo, true);
   double previous_bar_info=CopyRates(_Symbol,PERIOD_M5,1,Bars(_Symbol,PERIOD_M5),PrevPriceInfo);
   string Bullish_Pin="";
   if(PrevPriceInfo[1].close>PrevPriceInfo[1].open)
      {
      if(((PrevPriceInfo[1].close-PrevPriceInfo[1].open)/(PrevPriceInfo[1].high-PrevPriceInfo[1].low))<0.25)
         {
         if((PrevPriceInfo[1].close>PrevPriceInfo[1].low+0.75*(PrevPriceInfo[1].high-PrevPriceInfo[1].low)))
            {
            Bullish_Pin="Bullish Pin";
            } 
         }     
      }
      
   //--PREVIOUS CANDLE BEARISH PIN?
   string Bearish_Pin="";
   if(PrevPriceInfo[1].close<PrevPriceInfo[1].open)
      {
      if(((PrevPriceInfo[1].open-PrevPriceInfo[1].close)/(PrevPriceInfo[1].high-PrevPriceInfo[1].low))<0.25)
         {   
         if((PrevPriceInfo[1].close<PrevPriceInfo[1].high-0.75*(PrevPriceInfo[1].high-PrevPriceInfo[1].low)))
            {      
            Bearish_Pin="Bearish Pin";
            } 
         }     
      }
      

   //--PREVIOUS CANDLE BULLISH ENGULFING?
   MqlRates BarBeforeLastInfo[];
   ArraySetAsSeries(BarBeforeLastInfo,true);
   double bar_before_last=CopyRates(_Symbol,PERIOD_M5,2,Bars(_Symbol,PERIOD_M5),BarBeforeLastInfo);
   string Bullish_Engulfing="";
   if(PrevPriceInfo[1].close>PrevPriceInfo[1].open)
      {
      if(PrevPriceInfo[1].close>BarBeforeLastInfo[1].high)
         {
         if(BarBeforeLastInfo[1].close<BarBeforeLastInfo[1].open)
            {  
            Bullish_Engulfing="Bullish Engulfing";
            }
         }
      }
      
      
   //--PREVIOUS CANDLE BEARISH ENGULFING?
   string Bearish_Engulfing="";
   if(PrevPriceInfo[1].close<PrevPriceInfo[1].open)
      {
      if(PrevPriceInfo[1].close<BarBeforeLastInfo[1].low)
         {
         if(BarBeforeLastInfo[1].close>BarBeforeLastInfo[1].open)
            {  
            Bearish_Engulfing="Bearish Engulfing";
            }
         }
      }
   
   //--GOOD LONG ENTRY POINT?
   double ema_5M_50=iMA(_Symbol,PERIOD_M5,50,1,1,PRICE_CLOSE);
   string Good_long_entry="";
   if(PrevPriceInfo[1].close<ema_5M_50)
      {
      Good_long_entry="Good long entry";
      }
   else
      {
      Good_long_entry="Poor long entry";
      }
   
   
   //--GOOD SHORT ENTRY POINT?
   string Good_short_entry="";
   if(PrevPriceInfo[1].close>ema_5M_50)
      {  
      Good_short_entry="Good short entry";
      }
   else
      {
      Good_short_entry="Poor short entry";
      }
   
   //--Place trade
   if(isNewBar(_Symbol, PERIOD_M5)==true)
      {
      if(hourly_trend=="Hourly uptrend")
         {
         if(M15_trend=="M15 uptrend")
            {
            if(Bullish_Pin=="Bullish Pin")
               {
               if(Good_long_entry=="Good long entry")
               trade.Buy(0.03,_Symbol,Ask,Ask-200*_Point,Ask+300*_Point,NULL);
                  
               }
            }
         }
      }
                  
   if(isNewBar(_Symbol, PERIOD_M5)==true)
      {
      if(hourly_trend=="Hourly uptrend")
         {
         if(M15_trend=="M15 uptrend")
            {
            if(Bullish_Engulfing=="Bullish Engulfing")
               {
               if(Good_long_entry=="Good long entry")
               trade.Buy(0.03,_Symbol,Ask,Ask-200*_Point,Ask+300*_Point,NULL);
                  
               }
            }
         }
      }
      
   if(isNewBar(_Symbol, PERIOD_M5)==true)
      {
      if(hourly_trend=="Hourly downtrend")
         {
         if(M15_trend=="M15 downtrend")
            {
            if(Bearish_Pin=="Bearish Pin")
               {
               if(Good_short_entry=="Good short entry")
               trade.Sell(0.03,_Symbol,Bid,Bid-200*_Point,Bid+300*_Point,NULL);
                  
               }
            }
         }
      }
          
   if(isNewBar(_Symbol, PERIOD_M5)==true)
      {
      if(hourly_trend=="Hourly downtrend")
         {
         if(M15_trend=="M15 downtrend")
            {
            if(Bearish_Engulfing=="Bearish Engulfing")
               {
               if(Good_short_entry=="Good short entry")
               trade.Sell(0.03,_Symbol,Bid,Bid-200*_Point,Bid+300*_Point,NULL);
                  
               }
            }
         }
      }  
   }
   

   
   
   
   
     
   
                 
         
      
   
   
  
   
      
   
      
   
     
   



   
  
   
      
   
   
   
   
   
   
   
      
     


   
